// Code generated by go-swagger; DO NOT EDIT.

package images

// This file was generated by the swagger tool.
// Editing this file might prove futile when you re-run the generate command

import (
	"net/http"

	"github.com/go-openapi/runtime/middleware"
)

// ImageStopHandlerFunc turns a function with the right signature into a image stop handler
type ImageStopHandlerFunc func(ImageStopParams) middleware.Responder

// Handle executing the request and returning a response
func (fn ImageStopHandlerFunc) Handle(params ImageStopParams) middleware.Responder {
	return fn(params)
}

// ImageStopHandler interface for that can handle valid image stop params
type ImageStopHandler interface {
	Handle(ImageStopParams) middleware.Responder
}

// NewImageStop creates a new http.Handler for the image stop operation
func NewImageStop(ctx *middleware.Context, handler ImageStopHandler) *ImageStop {
	return &ImageStop{Context: ctx, Handler: handler}
}

/*ImageStop swagger:route DELETE /api/images/{id} Images imageStop

Stop image building

*/
type ImageStop struct {
	Context *middleware.Context
	Handler ImageStopHandler
}

func (o *ImageStop) ServeHTTP(rw http.ResponseWriter, r *http.Request) {
	route, rCtx, _ := o.Context.RouteInfo(r)
	if rCtx != nil {
		r = rCtx
	}
	var Params = NewImageStopParams()

	if err := o.Context.BindValidRequest(r, route, &Params); err != nil { // bind params
		o.Context.Respond(rw, r, route.Produces, route, err)
		return
	}

	res := o.Handler.Handle(Params) // actually handle the request

	o.Context.Respond(rw, r, route.Produces, route, res)

}
